unit DDes;

interface

uses
  Windows, Classes, Graphics, Controls, Forms,
  Buttons, StdCtrls, UDes;

type
  TFDes = class(TForm)
    GroupBoxM: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    RadioButton11: TRadioButton;
    RadioButton12: TRadioButton;
    RadioButton13: TRadioButton;
    RadioButton14: TRadioButton;
    RadioButton15: TRadioButton;
    RadioButton16: TRadioButton;
    RadioButton17: TRadioButton;
    RadioButton18: TRadioButton;
    RadioButton19: TRadioButton;
    RadioButton20: TRadioButton;
    RadioButton21: TRadioButton;
    RadioButton22: TRadioButton;
    RadioButton23: TRadioButton;
    RadioButton24: TRadioButton;
    RadioButton25: TRadioButton;
    RadioButton26: TRadioButton;
    RadioButton27: TRadioButton;
    RadioButton28: TRadioButton;
    RadioButton29: TRadioButton;
    LabelD: TLabel;
    LabelT: TLabel;
    LabelM: TLabel;
    LabelV: TLabel;
    ComboBoxT: TComboBox;
    ComboBoxM: TComboBox;
    ComboBoxV: TComboBox;
    ComboBoxD: TComboBox;
    LabelMasc: TLabel;
    LabelFem: TLabel;
    LabelNeut: TLabel;
    BitBtn3: TBitBtn;
    MemoMasc: TMemo;
    MemoFem: TMemo;
    MemoNeut: TMemo;
    ListBoxMasc: TListBox;
    ListBoxFem: TListBox;
    ListBoxNeut: TListBox;
    BModif1: TBitBtn;
    BModif2: TBitBtn;
    BModif3: TBitBtn;
    procedure ChangeModele(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtnModifClick(Sender: TObject);
  private
    function GetModele: integer;
    procedure SetModele(const Value: integer);
    function GetMode: integer;
    function GetTemps: integer;
    function GetVoix: integer;
    procedure SetMode(const Value: integer);
    procedure SetTemps(const Value: integer);
    procedure SetVoix(const Value: integer);
    function GetDegre: integer;
    procedure SetDegre(const Value: integer);
    { Dclarations prives }
  public
    { Dclarations publiques }
    modifie : boolean;
    property modele : integer read GetModele write SetModele;
    property temps : integer read GetTemps write SetTemps;
    property mode : integer read GetMode write SetMode;
    property voix : integer read GetVoix write SetVoix;
    property degre : integer read GetDegre write SetDegre;
  end;

var
  FDes: TFDes;

implementation

{$R *.dfm}

Uses utiles, Ulistes, DSaisieD;

procedure TFDes.ChangeModele(Sender: TObject);
const
   pers: array[0..5] of string =
      ('je', 'tu', 'il', 'nous', 'vous', 'ils');
   cas: array[0..5] of string =
      ('NOM', 'VOC', 'ACC', 'GEN', 'DAT', 'ABL');
var
   M : integer;
begin
   // lire les dsinences, et enregistrer si elles ont chang.

   // rgler l'affichage en fonction du modle
   // verbe :
   M := modele;
   LabelT.Visible := (M > 16) and (M < 29);
   ComboBoxT.Visible := LabelT.Visible;
   LabelM.Visible := LabelT.Visible;
   ComboBoxM.Visible := LabelT.Visible;
   LabelV.Visible := LabelT.Visible;
   ComboBoxV.Visible := LabelT.Visible;
   // adjectif
   LabelD.Visible := (M > 10) and (M < 17);
   ComboBoxD.Visible := LabelD.Visible;

   // affichage des dsinences :
   case M of
      0..10 : // noms
         begin
            MemoMasc.Lines := array2stringlist(Cas);
            MemoMasc.Lines.AddStrings(array2stringlist(Cas));
            ListBoxMasc.items := Desinences.graphie[M, -1, -1, -1, -1, -1];
            ListBoxFem.Hide;
            MemoFem.Hide;
            ListBoxNeut.Hide;
            MemoNeut.Hide;
            LabelMasc.Hide;
            LabelFem.Hide;
            LabelNeut.Hide;
         end;
      11..16 : // adjectifs
         begin
            ListBoxMasc.Items := Desinences.graphie[M, 0, -1, -1, -1, degre];
            ListBoxFem.Items := Desinences.graphie[M, 1, -1, -1, -1, degre];
            ListBoxNeut.Items := Desinences.graphie[M, 2, -1, -1, -1, degre];
            ListBoxFem.Show;
            MemoMasc.Lines := array2stringlist(Cas);
            MemoMasc.Lines.AddStrings(array2stringList(Cas));
            MemoFem.Show;
            ListBoxNeut.Show;
            MemoNeut.Show;
            LabelMasc.Show;
            LabelFem.Show;
            LabelNeut.Show;
         end;
      17..28 : // verbes
         begin
            case mode of
              0..2 :
                 begin
                    ListBoxMasc.Items :=
                       Desinences.graphie[M, -1, mode, temps, voix, -1];
                    MemoMasc.Lines := Array2StringList(pers);
                    MemoFem.Hide;
                    ListBoxFem.Hide;
                    MemoNeut.Hide;
                    ListBoxNeut.Hide;
                    LabelMasc.Hide;
                    LabelFem.Hide;
                    LabelNeut.Hide;
                  end;
               3 :  // infinitif;
                  begin
                    ListBoxMasc.Items :=
                       Desinences.graphie[M, -1, mode, temps, voix, -1];
                    MemoFem.Hide;
                    MemoNeut.Hide;
                    LabelMasc.Hide;
                    LabelFem.Hide;
                    LabelNeut.Hide;
                  end;
               4 .. 6 : // participe, grondif, adj. verbal.
                  begin
                      ListBoxMasc.Items :=
                         Desinences.graphie[M, 0, mode, temps,  voix, -1];
                      ListBoxFem.Items :=
                         Desinences.graphie[M, 1, mode, temps, voix, -1];
                      ListBoxNeut.Items :=
                         Desinences.graphie[M, 2, mode, temps, voix, -1];
                      MemoMasc.Lines := array2StringList(Cas);
                      MemoMasc.Lines.AddStrings(array2stringList(Cas));
                      MemoFem.Show;
                      MemoNeut.Show;
                      LabelMasc.Show;
                  end;
            end;
         end;
      end;
  // complter l'affichage
  ListBoxFem.Visible := MemoFem.Visible;
  LabelFem.Visible := MemoFem.Visible;
  BModif2.Visible := MemoFem.Visible;
  ListBoxNeut.Visible := MemoNeut.Visible;
  LabelNeut.Visible := MemoNeut.Visible;
  BModif3.Visible := MemoNeut.Visible;

  // rgler la hauteur des listes;
  with ListBoxMasc
     do Height := ItemHeight * Items.count + 2;
end;

function TFDes.GetModele: integer;
   var i : integer;
begin
   result := -1;
   for i := 0 to GroupBoxM.ControlCount - 1 do
      if (GroupBoxM.Controls[i] is TRadioButton)
         and (TRadioButton(GroupBoxM.Controls[i]).Checked) then
         begin
            result := GroupBoxM.Controls[i].Tag;
            break;
         end;
end;

procedure TFDes.SetModele(const Value: integer);
  var i : integer;
begin
   for i := 0 to GroupBoxM.ControlCount - 1 do
      if (GroupBoxM.Controls[i] is TRadioButton)
         and (GroupBoxM.Controls[i].tag = Value) then
         begin
            TRadioButton(GroupBoxM.Controls[i]).Checked := true;
            break;
         end;
end;

procedure TFDes.FormCreate(Sender: TObject);
begin
   // peupler les combos de morpho
   ComboBoxT.Items := Array2StringList(ListeTemps);
   ComboBoxT.ItemIndex := 0;
   ComboBoxM.Items := Array2StringList(ListeModes);
   ComboBoxM.ItemIndex := 0;
   ComboBoxV.Items := Array2StringList(ListeVoix);
   ComboBoxV.ItemIndex := 0;
   ComboBoxD.Items := Array2StringList(ListeDegres);
   ComboBoxD.ItemIndex := 0;
   ChangeModele(nil);
end;

function TFDes.GetMode: integer;
begin
   result := ComboBoxM.ItemIndex;
end;

function TFDes.GetTemps: integer;
begin
   result := ComboBoxT.ItemIndex;
end;

function TFDes.GetVoix: integer;
begin                 
   result := ComboBoxV.ItemIndex;
end;

procedure TFDes.SetMode(const Value: integer);
begin
   ComboBoxM.ItemIndex := Value;
end;

procedure TFDes.SetTemps(const Value: integer);
begin
   ComboBoxT.ItemIndex := Value;
end;

procedure TFDes.SetVoix(const Value: integer);
begin         
   ComboBoxV.ItemIndex := Value;
end;

function TFDes.GetDegre: integer;
begin
   result := ComboBoxD.ItemIndex;
end;

procedure TFDes.SetDegre(const Value: integer);
begin
   ComboBoxD.ItemIndex := Value;
end;

procedure TFDes.BtnModifClick(Sender: TObject);
var
   Cible : TListBox;
   liste : TStringList;
   G : integer;
begin
// modifier la liste slectionne
// 1. Dfinir la cible
   G := (Sender as TComponent).Tag;
   case G of
      1 : Cible := ListBoxMasc;
      2 : Cible := ListBoxFem;
      3 : Cible := ListBoxNeut;
      end;
// 2. peupler le Mmo de la forme de saisie
FSaisieD.Memo1.Lines := Cible.Items;
// 3. Saisie
if FSaisieD.ShowModal = mrOK then
   begin
      Cible.Items := FSaisieD.Memo1.Lines;
      modifie := true;
   end;
// 4. rcupration
liste := TStringList.Create;
liste.AddStrings(Cible.Items);
Desinences.Graphie[modele, G -1, mode, temps, voix, degre] := liste;
liste.free;
end;

end.
