unit DDico;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons;

type
  TFDico = class(TForm)
    EditC: TEdit;
    BtnEdit: TBitBtn;
    BitBtn3: TBitBtn;
    Label1: TLabel;
    BtnSuppr: TBitBtn;
    LabelT: TLabel;
    procedure EditCKeyPress(Sender: TObject; var Key: Char);
    procedure EditCChange(Sender: TObject);
    procedure BtnEditClick(Sender: TObject);
    procedure BtnSupprClick(Sender: TObject);
    procedure EditCKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Dclarations prives }
    arriere : boolean;
    p : integer;
  public
    { Dclarations publiques }
  end;

var
  FDico: TFDico;

implementation

{$R *.dfm}

uses ULex, DLex;

procedure TFDico.EditCKeyPress(Sender: TObject; var Key: Char);
begin
  // empcher le dispositif de rafficher le mot suivant
  // permet le retour en arrire.
  arriere := Key = #8;
end;

procedure TFDico.EditCChange(Sender: TObject);
var
   textus : string;
   l : integer;
   affiche : boolean;
begin
  textus := lowerCase(EditC.text);
  affiche := true;
  if not Lexique.Find(EditC.text, p) then
     with Lexique
         do if not arriere then
            begin
              if p >= Lexique.count
                then p := Lexique.count - 1;
              if pos(EditC.Text, Lexique[p]) = 1 then
                begin
                  l := length(Textus);
                  EditC.Text := Textus
                    + copy(strings[p], l + 1, length(strings[p]));
                  EditC.selStart := l;
                  EditC.selLength := 99;
                end
                else affiche := false;
            end
            else affiche := false;
  if affiche
     then
        begin
           p := p;
           LabelT.Caption := Lexique.Donnees(p, true).texte;
           BtnEdit.Caption := '&Modifier';
        end
     else
        begin
           LabelT.Caption := 'entre inexistante';
           BtnEdit.Caption := '&Ajouter';
        end;
end;

procedure TFDico.BtnEditClick(Sender: TObject);
   var D : TDonneesLexicales;
begin
   if BtnEdit.Caption = '&Ajouter' then
      begin
         D := TDonneesLexicales.Create(-1, -1, '', '', '');
         Flex.Affiche(EditC.Text, D);
         D.Free;
         if Flex.ShowModal = mrOK
            then Lexique.AjouteAuLexique( false, Flex.Entree, Flex.Donnees);
      end
      else
      begin
         Flex.Affiche(Lexique[p], Lexique.Donnees(p, true));
         if Flex.ShowModal = mrOK
            then Lexique.AjouteAuLexique( true, Flex.Entree, Flex.Donnees );
      end;
end;

procedure TFDico.BtnSupprClick(Sender: TObject);
begin
   Lexique.DeleteLexico(p);
end;

procedure TFDico.EditCKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
     VK_UP : if p > 0 then
        begin
           dec(p);
           EditC.Text := Lexique[p];
        end;
     VK_DOWN : if p < lexique.Count - 1 then
        begin
          inc(p);
          EditC.Text := Lexique[p];
        end;
     end;
end;

end.
