unit DLex;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, ULex;

type
  TFLex = class(TForm)
    GroupBoxM: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    RadioButton11: TRadioButton;
    RadioButton12: TRadioButton;
    RadioButton13: TRadioButton;
    RadioButton14: TRadioButton;
    RadioButton15: TRadioButton;
    RadioButton16: TRadioButton;
    RadioButton17: TRadioButton;
    RadioButton18: TRadioButton;
    RadioButton19: TRadioButton;
    RadioButton20: TRadioButton;
    RadioButton21: TRadioButton;
    RadioButton22: TRadioButton;
    RadioButton23: TRadioButton;
    RadioButton24: TRadioButton;
    RadioButton25: TRadioButton;
    RadioButton26: TRadioButton;
    RadioButton27: TRadioButton;
    RadioButton28: TRadioButton;
    RadioButton29: TRadioButton;
    RadioButton30: TRadioButton;
    RadioButton31: TRadioButton;
    EditCanon: TEdit;
    Label1: TLabel;
    EditR2: TEdit;
    LabelR2: TLabel;
    EditR3: TEdit;
    LabelR3: TLabel;
    MemoT: TMemo;
    RadioGroupG: TRadioGroup;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label4: TLabel;
    procedure ChangeM(Sender: TObject);
  private
    function GetModele: integer;
    procedure SetModele(const Value: integer);
    function GetGenre: integer;
    procedure SetGenre(const Value: integer);
    { Dclarations prives }
  public
    { Dclarations publiques }
    property Modele : integer read GetModele write SetModele;
    property Genre : integer read GetGenre write SetGenre;
    function Entree : string;
    function Donnees : TDonneesLexicales;
    procedure Affiche (Entree : String ; Donnees : TDonneesLexicales);
  end;

var
  FLex: TFLex;

implementation

{$R *.dfm}

uses Ulistes;

{ TFLex }

procedure TFLex.Affiche(Entree: String; Donnees: TDonneesLexicales);
begin
  // affiche Entree et Donnees dans la forme;
  EditCanon.Text := Entree;
  Modele := Donnees.modele;
  genre := Donnees.genre;
  EditR2.Text := Donnees.Radical2;
  EditR3.Text := Donnees.Radical3;
  MemoT.Text := Donnees.texte;
end;

procedure TFLex.ChangeM(Sender: TObject);
   var M : integer;
begin
  // afficher le modle
  M := Modele;
  { suivant la valeur du modle, activer ou dsactiver
    les genres ou les radicaux }
  // genres
  RadioGroupG.visible := (M < 11) and (M > -1);
  if not RadioGroupG.Enabled then RadioGroupG.ItemIndex := -1;
  // radical 2
  case M of
     5..8, 14..16 :
        begin
           LabelR2.Caption := '&Radical de gnitif';
           LabelR2.Show;
           EditR2.Show;
        end;
     17..28 :
        begin
           LabelR2.Caption := '&Radical de parfait';
           LabelR2.Show;
           EditR2.Show;
        end;
     else
        begin
           LabelR2.Hide;
           EditR2.Hide;
        end;
     end;
  // radical 3
  LabelR3.Visible := (M > 16) and (M < 29) and (M <> 22); // 22 = sum
  EditR3.Visible := LabelR3.Visible;
end;

function TFLex.Donnees: TDonneesLexicales;
   var g : integer;
       r2, r3 : string;
begin
   // renvoie les donnes actuelles de la forme
   if not RadioGroupG.Visible
      then g := -1
      else g := genre;
   if not EditR2.Visible
      then r2 := ''
      else r2 := EditR2.Text;
   if not EditR3.Visible
      then r3 := ''
      else r3 := EditR3.Text;
   result := TDonneesLexicales.Create(
      Modele,
      g,
      MemoT.Text,
      EditR2.Text,
      EditR3.Text);
end;

function TFLex.Entree: string;
begin
  // renvoie l'entre actuelle.
  Result := EditCanon.Text;
end;

function TFLex.GetGenre: integer;
begin
   result := RadioGroupG.ItemIndex;
end;

function TFLex.GetModele: integer;
   var i : integer;
begin
   result := -1;
   for i := 0 to GroupBoxM.ControlCount - 1 do
      if (GroupBoxM.Controls[i] is TRadioButton)
         and (TRadioButton(GroupBoxM.Controls[i]).Checked) then
         begin
            result := GroupBoxM.Controls[i].Tag;
            break;
         end;
end;

procedure TFLex.SetGenre(const Value: integer);
begin
   RadioGroupG.ItemIndex := Value;
end;

procedure TFLex.SetModele(const Value: integer);
  var i : integer;
begin
   for i := 0 to GroupBoxM.ControlCount - 1 do
      if (GroupBoxM.Controls[i] is TRadioButton)
         and (GroupBoxM.Controls[i].tag = Value) then
         begin
            TRadioButton(GroupBoxM.Controls[i]).Checked := true;
            break;
         end;
end;

end.
